#!/bin/sh

set -eu

if [ $# -lt 2 ]
then
  echo "$0: [SONAME] [ARCHIVE] [options]"
  exit 1
fi

SONAME=$1
ARCHIVE=$2
shift
shift

OBJECT_MODE=${OBJECT_MODE:-64}
export OBJECT_MODE

CC=${CC:-gcc}

if [ "$OBJECT_MODE" = '64' ]
then
  SHR=shr_64
else
  SHR=shr
fi


TMPDIR=tmp-$$
mkdir $TMPDIR

(
    echo '#! '"$SONAME($SHR.o)"
    echo "# $OBJECT_MODE"
    /QOpenSys/usr/bin/nm -BCpg "$ARCHIVE" | awk '{ if ((($2 == "T") || ($2 == "D") || ($2 == "B")) && (substr($3,1,1) != ".")) { print $3 } }' | sort -u
) > $TMPDIR/$SHR.imp

$CC -Wl,-bE:$TMPDIR/$SHR.imp -shared -o $TMPDIR/$SHR.o "$ARCHIVE" "$@"
/QOpenSys/usr/bin/strip -e $TMPDIR/$SHR.o

ar crlo $SONAME $TMPDIR/$SHR.imp $TMPDIR/$SHR.o

rm -r $TMPDIR
